<template>
  <i-wrapper top>
    <i-stepper :total="auth.onboarding.total" :filled="7" />
    <i-curtain tag="form" @submit="submit()">
      <img src="~assets/images/bubbles-orange.svg" class="bubbles bubbles--custom" />
      <img src="~assets/images/scientist-hello.png" class="scientist-hello" />
      <div class="title px-1 text-center">
        {{ $t(`What are your interests {name}?`, { name: auth.onboarding.name }) }}
      </div>
      <div class="normal-text text-center px-1 mb-1">
        {{ $t(`Information about which areas of your life would you like to see in the predictions?`) }}
      </div>
      <i-round-options
        ref="relationshipOptions"
        v-model="interests"
        :options="interestOptions"
        :options-per-line="3"
        multiple />
      <template #bottom>
        <i-button submit block :loading="isLoading" :disabled="isLoading">{{ $t(`CONTINUE`) }}</i-button>
      </template>
    </i-curtain>
  </i-wrapper>
</template>

<script>
  import { mapState } from 'vuex';

  export default {
    layout: 'default',

    data() {
      return {
        interests: this.$store.state.auth.onboarding.interests || [],
        isLoading: false,

        interestOptions: [
          {
            key: 'RELATIONSHIP',
            title: this.$t('Relationship'),
            defaultImage: 'relationship.svg',
            selectedImage: 'relationship-colored.svg',
          },
          { key: 'HEALTH', title: this.$t('Health'), defaultImage: 'health.svg', selectedImage: 'health-colored.svg' },
          {
            key: 'EDUCATION',
            title: this.$t('Education'),
            defaultImage: 'education.svg',
            selectedImage: 'education-colored.svg',
          },
          {
            key: 'CAREER',
            title: this.$t('Career'),
            defaultImage: 'career.svg',
            selectedImage: 'career-colored.svg',
          },
          {
            key: 'FAMILY',
            title: this.$t('Family'),
            defaultImage: 'family.svg',
            selectedImage: 'family-colored.svg',
          },
          {
            key: 'FRIENDS',
            title: this.$t('Friends'),
            defaultImage: 'friends.svg',
            selectedImage: 'friends-colored.svg',
          },
        ],
      };
    },

    computed: {
      ...mapState(['auth']),
    },

    mounted() {
      //
    },

    methods: {
      async submit() {
        if (this.isLoading) {
          return;
        }

        console.log('SUBMIT');

        if (this.interests.length === 0) {
          this.$refs.relationshipOptions.$refs.root.classList.add('bounce');

          setTimeout(() => {
            this.$refs.relationshipOptions.$refs.root.classList.remove('bounce');
          }, 1000);

          return;
        }

        this.isLoading = true;

        try {
          let response = await this.$axios.post(`onboarding/interests`, {
            interests: this.interests,
          });

          ga('send', 'event', 'onb_7_interests');
          this.$store.commit('MERGE_AUTH', { onboarding: response.data.data, user: response.data.data.user });
          await this.$router.push(this.localePath({ name: 'onboarding.notifications' }));
        } catch (error) {
          this.isLoading = false;
          throw error;
        }
      },
    },
  };
</script>

<style lang="scss">
  .scientist-hello {
    width: rw(50px);
    margin-top: rs(30px);
  }

  .title {
    font-weight: bold;
    font-size: rf(20px);
    margin-top: rs(15px);
  }

  .normal-text {
    font-size: rf(16px);
    margin-top: rs(10px);
  }

  .bubbles--custom {
    top: rs(147px);
  }
</style>
